package de.duehl.swing.ui.layout.card;

import java.awt.Component;

/*
 * Copyright 2016 Christian Dühl. All rights reserved.
 *
 * This program is free software. You can redistribute it and/or
 * modify it under the same terms as perl:
 *
 * general:  http://dev.perl.org/licenses/
 * GPL:      http://dev.perl.org/licenses/gpl1.html
 * artistic: http://dev.perl.org/licenses/artistic.html
 */

public class Card {

    private final String name;
    private final CardGui gui;
    private final CardLogic logic;

    public Card(String name, CardGui gui, CardLogic logic) {
        this.name = name;
        this.gui = gui;
        this.logic = logic;
        logic.setGui(gui);
        gui.setLogic(logic);
    }

    String getName() {
        return name;
    }

    Component createCardGui(CardSwitcher switcher) {
        return gui.createGui(switcher);
    }

    void runWhenShown(Card previousCard) {
        CardLogic previousLogic = previousCard.logic;
        CardResult result = previousLogic.getResult();
        logic.setResultFromPreviousCard(result);
        logic.runWhenShown();
    }

    void cleanUp() {
        gui.cleanUp();
    }

}
